package functions;

import java.util.Vector;
import java.io.*;

public class Settings
{
	static private Vector<String> mNames; 
	static private Vector<String> mValues;
	static private String mPath;

	public static Boolean loadConfig(String path)
	{
		mNames = new Vector<String>();
		mValues = new Vector<String>();
		mPath = path;

		try
		{
			FileReader fr = new FileReader(mPath);
			BufferedReader br = new BufferedReader(fr);
			String line;
			String buf[];
			int tmp;

			while((line = br.readLine()) != null)
			{
				tmp = line.indexOf('#');
				if (tmp >= 0)
					line = line.substring(0, tmp);
				
				tmp = line.indexOf('=');
				if (tmp < 0) /* Linia zjebana */
					continue;

				buf = line.split("=", 2);
				buf[0] = buf[0].trim();
				buf[1] = buf[1].trim();
				setValue(buf[0], buf[1]);
			}
			fr.close();
		}
		catch (Exception e)
		{
			/* Blad czytania z pliku */
			return false;
		}

		return true;
	}

	static public Boolean saveConfig()
	{
		try
		{
			FileWriter fw = new FileWriter(mPath);
			fw.write("# File autogenerated!\n");
			fw.write("# Don't touch or you will die!\n");
			for (int i = 0;i < mNames.size();i++)
			{
				fw.write(mNames.get(i) + "=" + mValues.get(i) + "\n");				
			}
			fw.close();
		}
		catch (Exception e)
		{
			/* Blad zapisu do pliku */
			return false;
		}		
		return true;
	}

	static public String getValue(String name)
	{
		for(int i = 0;i < mNames.size();i++)
		{
			if (mNames.get(i).equals(name))
				return mValues.get(i);
		}
		return "";
	}

	static public void setValue(String name, String value)
	{
		for(int i = 0;i < mNames.size();i++)
		{
			if (mNames.get(i).equals(name))
			{				
				mValues.setElementAt(value, i);
				return;
			}
		}
		mNames.add(name);
		mValues.add(value);
	}
}

 
