/*Menu bar for main window*/
package ui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JMenuBar;
import javax.swing.ImageIcon;
import ui.config.Config;
import ui.history.History;
import ui.addlinks.AddLinks;
import ui.about.About;;
import javax.swing.AbstractButton;
import javax.swing.JOptionPane;

public class MenuBar extends JMenuBar  implements ActionListener{
  JMenu mFile, mEdit, mHelp;
  JMenuItem mFileAdd,mFileClose;
  JMenuItem mEditStart,mEditPause,mEditRemove,mEditHistory,mEditOptions;
  JMenuItem mHelpHelps,mHelpAbout;
  MainWindow mParent;

  public MenuBar(MainWindow parent){
    super();
    mParent = parent;
    makeFile();
    makeEdit();
    makeHelp();
  }

  private void makeFile(){
    this.mFile = new JMenu("File");
    this.mFile.setMnemonic(KeyEvent.VK_F);
    this.add(mFile);

    mFileAdd = new JMenuItem("Add Links",new ImageIcon("graphics/add_small.png"));
    mFile.add(mFileAdd);
    mFile.addSeparator();
    mFileAdd.setActionCommand("links");
    mFileAdd.addActionListener(this);

    mFileClose = new JMenuItem("Close",new ImageIcon("graphics/close.png"));
    mFile.add(mFileClose);
  }

  private void makeEdit(){
    this.mEdit = new JMenu("Edit");
    this.mEdit.setMnemonic(KeyEvent.VK_E);
    this.add(mEdit);
  
    mEditStart = new JMenuItem("Start download",new ImageIcon("graphics/start_small.png"));
    mEditStart.setActionCommand("start");
    mEditStart.addActionListener(this);
    mEdit.add(mEditStart);
  
    mEditPause = new JMenuItem("Pause download",new ImageIcon("graphics/pause_small.png"));
    mEditPause.setActionCommand("pause");
    mEditPause.addActionListener(this);
    mEdit.add(mEditPause);
  
    mEditRemove = new JMenuItem("Remove position",new ImageIcon("graphics/remove_small.png"));
    mEditRemove.setActionCommand("remove");
    mEditRemove.addActionListener(this);
    mEdit.add(mEditRemove);
    mEdit.addSeparator();
  
    mEditHistory = new JMenuItem("Show history",new ImageIcon("graphics/history.png"));
    mEdit.add(mEditHistory);
    mEdit.addSeparator();
    mEditHistory.setActionCommand("history");
    mEditHistory.addActionListener(this);
  
    mEditOptions = new JMenuItem("Preferences...",new ImageIcon("graphics/options.png"));
    mEdit.add(mEditOptions);
    mEditOptions.setActionCommand("options");
    mEditOptions.addActionListener(this);
  }

  private void makeHelp(){
    this.mHelp = new JMenu("Help");
    this.mHelp.setMnemonic(KeyEvent.VK_H);
    this.add(mHelp);
  
    mHelpHelps = new JMenuItem("Show Help",new ImageIcon("graphics/help.png"));
    mHelp.add(mHelpHelps);
    mHelp.addSeparator();
    mHelpHelps.setActionCommand("help");
    mHelpHelps.addActionListener(this);

    mHelpAbout = new JMenuItem("About JGetRap",new ImageIcon("graphics/about.png"));
    mHelp.add(mHelpAbout);
    mHelpAbout.setActionCommand("about");
    mHelpAbout.addActionListener(this);
  }
  public void actionPerformed(ActionEvent e) {
    if ("options".equals(e.getActionCommand())) {
      Config config = new Config();
      config.setVisible(true);
    } else if("history".equals(e.getActionCommand())){
      History history = new History(mParent);
      history.setVisible(true);
    } else if("links".equals(e.getActionCommand())){
      AddLinks links = new AddLinks(mParent,"");
      links.setVisible(true);
      mParent.setDodaj(links);
      mParent.setDodajIsOpen(mParent.dodajIsOpen()+1);
    } else if("about".equals(e.getActionCommand())){
      About about = new About();
      about.setVisible(true);
    } else if("help".equals(e.getActionCommand())){
      JOptionPane.showMessageDialog(null,"SOA #1","help",JOptionPane.INFORMATION_MESSAGE);
        } else if("remove".equals(e.getActionCommand())){
      mParent.remove();
      mParent.getTable().updateUI();
    } else if("pause".equals(e.getActionCommand())){
      mParent.pause();
      mParent.getTable().updateUI();
    } else if("start".equals(e.getActionCommand())){
      mParent.start();
      mParent.getTable().updateUI();
    }
} 



}
