package ui.config;

import javax.swing.JFrame;
import javax.swing.JTabbedPane;
import javax.swing.JTabbedPane;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
import functions.*;
import java.util.Vector;
import javax.swing.event.*;
import engine.*;

public class Config extends JFrame implements ActionListener{
private JTabbedPane panel;
private JComponent connections, directories, plugins, pluginy;
JTextField conn_try,conn_try_time,directory,parallel_downloads,proxy_serv,refresh_time;
JButton ok,cancel,destiny;
JLabel conn_info,fold,parallel,refresh_label;
JCheckBox proxy,update_app,update_plugin,try_monitor,auto_clean,auto_update;
JTable plug;


public Config(){
 super("JGetRap :: Configuration");
 setSize(600,300);
 setResizable(false);
 panel = new JTabbedPane();
 directories = new JPanel();
 makeDownloads();
 connections = new JPanel();
 makeConnections();
 plugins = new JPanel();
 makeElse();
 pluginy = new JPanel();
 makePlugins();
 panel.addTab("Download",new ImageIcon("graphics/dev.png"),directories);
 panel.addTab("Connections",new ImageIcon("graphics/con.png"),connections);
 panel.addTab("Else",new ImageIcon("graphics/plug.png"),plugins);
 panel.addTab("Plugins",new ImageIcon("graphics/plug.png"),pluginy);
 ok = new JButton("ok",new ImageIcon("graphics/ok.png"));
 cancel = new JButton("cancel",new ImageIcon("graphics/no.png"));
    ok.setActionCommand("ok");
    ok.addActionListener(this);
    cancel.setActionCommand("cancel");
    cancel.addActionListener(this);
    this.setLayout(new GridBagLayout());
    GridBagConstraints c = new GridBagConstraints();
    c.fill = GridBagConstraints.HORIZONTAL;
    c.anchor = GridBagConstraints.PAGE_START;
    c.fill = GridBagConstraints.BOTH;
    c.gridx = 0;
    c.gridy = 0;
    c.weightx = 1.0;
    c.weighty = 1.0;
    c.gridwidth = 2;
    add(panel,c);
    c.insets = new Insets(10,10,10,10);  //top padding
    c.ipady = 10;
    c.ipadx = 20;
    c.anchor = GridBagConstraints.PAGE_END;
    c.gridx = 0;
    c.gridy = 1;
    c.weighty = 0.0;
    c.gridwidth = 1;
    add(ok,c);
    c.insets = new Insets(10,10,10,10);  //top padding
    c.gridx = 1;
    c.gridy = 1;
    c.weighty = 0.0;
    add(cancel,c);
}

private void makeConnections(){
  proxy=new JCheckBox("Chesz używać proxy",(Settings.getValue("PROXY").equals("yes"))?true:false);
  parallel=new JLabel("Ilość jednoczesnych pobierań : ");
  parallel_downloads = new JTextField(Settings.getValue("MAX_CONNECTIONS"));
  proxy_serv = new JTextField(Settings.getValue("PROXY_SERVER"));
  

  connections.setLayout(new GridBagLayout());
  GridBagConstraints c = new GridBagConstraints();
    c.anchor = GridBagConstraints.PAGE_START;
    c.fill = GridBagConstraints.BOTH;
    c.gridx = 0;
    c.gridy = 0;
    c.weightx = 0.0;
    c.gridwidth = 1;
    c.insets = new Insets(10,10,10,10); 
    connections.add(proxy,c);
    c.gridx = 0;
    c.weightx = 1.0;
    c.gridy = 1;
    c.gridwidth = 2;
    connections.add(parallel,c);
    c.gridx = 2;
    c.gridy = 1;
    c.gridwidth = 1;
    connections.add(parallel_downloads,c);
    c.gridx = 1;
    c.gridy = 0;
    c.gridwidth = 2;
    connections.add(proxy_serv,c);
    }


private void makeDownloads(){
  destiny = new JButton("Destiny",new ImageIcon("graphics/ok.png"));
  conn_try= new JTextField(Settings.getValue("MAX_TRY"));
  conn_try_time = new JTextField(Settings.getValue("TRY_TIME"));
  conn_info = new JLabel("ponowienie prób / czas");
  fold = new JLabel("Domyślny folder docelowy : ");
  destiny.setActionCommand("destiny");
  destiny.addActionListener(this);

  directory = new JTextField(Settings.getValue("PATH"));
   directories.setLayout(new GridBagLayout());
 GridBagConstraints c = new GridBagConstraints();
    c.anchor = GridBagConstraints.PAGE_START;
    c.fill = GridBagConstraints.BOTH;
    c.gridx = 0;
    c.gridy = 0;
    c.weightx = 0.0;
    c.gridwidth = 3;
    c.insets = new Insets(10,10,10,10); 
    directories.add(fold,c);
    c.gridx = 0;
    c.weightx = 1.0;
    c.gridy = 1;
    c.gridwidth = 2;
    directories.add(directory,c);
    c.gridx = 2;
    c.gridy = 1;
    c.gridwidth = 1;
    directories.add(destiny,c);
    c.gridx = 0;
    c.gridy = 2;
    directories.add(conn_info,c);
    c.gridx = 1;
    c.gridy = 2;
    directories.add(conn_try,c);
    c.gridx = 2;
    c.gridy = 2;
    directories.add(conn_try_time,c);
    }

private void makeElse(){
  refresh_time = new JTextField(Settings.getValue("REFRESH_LIST"));
  refresh_label = new JLabel("    Odświerzanie listy (w ms) : ");
  update_app = new JCheckBox("Sprawdzanie dostępności nowej wersji",
(Settings.getValue("NEW_VERSION_CHECK").equals("yes"))?true:false);
  update_plugin = new JCheckBox("Sprawdzanie dostępności nowych pluginów",
(Settings.getValue("PLUGIN_CHECK").equals("yes"))?true:false);
  try_monitor = new JCheckBox("Monitorowanie schowka ",
(Settings.getValue("CLIPBOARD").equals("yes"))?true:false);
  auto_clean = new JCheckBox("Samoczynne czyszczenie listy pobierania",
(Settings.getValue("CLEAR_LIST").equals("yes"))?true:false);
  auto_update = new JCheckBox("Samoczynne aktualizacje wtyczek",
(Settings.getValue("PLUGIN_UPDATE").equals("yes"))?true:false);
  
  
  plugins.setLayout(new GridBagLayout());
  GridBagConstraints c = new GridBagConstraints();
    c.anchor = GridBagConstraints.PAGE_START;
    c.fill = GridBagConstraints.BOTH;
    c.gridx = 0;
    c.gridy = 0;
    c.weightx = 0.0;
    c.gridwidth = 2;
    c.insets = new Insets(0,0,10,10); 
    plugins.add(refresh_label,c);
    c.gridx = 2;
    c.weightx = 1.0;
    c.gridy = 0;
    c.gridwidth = 2;
    plugins.add(refresh_time,c);
    c.gridx = 0;
    c.gridy = 1;
    c.gridwidth = 1;
    plugins.add(update_app,c);
    c.gridx = 0;
    c.gridy = 3;
    plugins.add(update_plugin,c);
    c.gridx = 0;
    c.gridy = 4;
    plugins.add(try_monitor,c);
    c.gridx = 0;
    c.gridy = 5;
    plugins.add(auto_clean,c);
    c.gridx = 0;
    c.gridy = 6;
    plugins.add(auto_update,c);
}

 private void makePlugins(){   
   Vector<String> titles = new Vector<String>();

    titles.add("Plugin");
    titles.add("Enabled");
	

  Vector<Vector<Object>> vect = Task.getPlugins();

    plug=new JTable(new DefaultTableModel(vect,titles)
		{
			@Override
			public boolean isCellEditable(int row, int column) {return false;}
		});

    JScrollPane scrollPane = new JScrollPane(plug);
    plug.setFillsViewportHeight(true);
    //scrollPane.setBounds(0,0,100,100);
		TableColumn col = plug.getColumnModel().getColumn(1);
		col.setMaxWidth(50);
		col.setMinWidth(50);
		plug.getColumnModel().getColumn(1).setCellRenderer(new CheckRenderer("true"));
		plug.setColumnSelectionAllowed(false);
		plug.setCellSelectionEnabled(false);
		plug.setRowSelectionAllowed(true);
		plug.setShowGrid(false);
		plug.setShowHorizontalLines(true) ;
    pluginy.setLayout(new GridBagLayout());
    GridBagConstraints c = new GridBagConstraints();
    c.anchor = GridBagConstraints.PAGE_START;
    c.fill = GridBagConstraints.BOTH;
    c.gridx = 0;
    c.gridy = 0;
    c.weightx = 1.0;
    c.weighty = 1.0;
    c.gridwidth = 1;
    c.insets = new Insets(0,0,10,10);
    pluginy.add(scrollPane,c);

   plug.addMouseListener(new MouseListener(){
		 public void mouseClicked(MouseEvent me) {
			int []idx = plug.getSelectedRows();
			for(int i=0;i<idx.length;i++)
			{
				Boolean newVal = !(Boolean)plug.getValueAt(idx[i], 1);
				plug.setValueAt(newVal, idx[i], 1);
				Task.setPluginEnabled((String)plug.getValueAt(idx[i], 0), newVal);
			}
		}

		public void mouseEntered(MouseEvent me) {
		}

		public void mouseExited(MouseEvent me) {
		}

		public void mousePressed(MouseEvent me) {		
		}

		public void mouseReleased(MouseEvent me) {			
		}
	});
  }

 public void actionPerformed(ActionEvent e) {
    if ("ok".equals(e.getActionCommand())) {
Settings.setValue("PATH",directory.getText());
Settings.setValue("MAX_TRY",conn_try.getText());
Settings.setValue("TRY_TIME",conn_try_time.getText());
Settings.setValue("PROXY",(proxy.isSelected())?"yes":"no");
Settings.setValue("PROXY_SERVER",proxy_serv.getText());
Settings.setValue("MAX_CONNECTIONS",parallel_downloads.getText());
Settings.setValue("CLIPBOARD",(try_monitor.isSelected())?"yes":"no");
Settings.setValue("NEW_VERSION_CHECK",(update_app.isSelected())?"yes":"no");
Settings.setValue("PLUGIN_CHECK",(update_plugin.isSelected())?"yes":"no");
Settings.setValue("PLUGIN_UPDATE",(auto_update.isSelected())?"yes":"no");
Settings.setValue("CLEAR_LIST",(auto_clean.isSelected())?"yes":"no");
Settings.setValue("REFRESH_LIST",refresh_time.getText());
Settings.saveConfig();
      setVisible(false);
           dispose();
    } else if("cancel".equals(e.getActionCommand())){
      setVisible(false);
           dispose();

    }else if("destiny".equals(e.getActionCommand())){
      JFileChooser fc = new JFileChooser(); 
      fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
      int returnVal = fc.showOpenDialog(this);
      directory.setText(fc.getSelectedFile().getAbsolutePath());  

    }
} 
}